#!/bin/bash

set -euo pipefail

SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )"

echo ""
echo "testing test_libs..."

# Run test_libs
if [ -f "${SCRIPT_DIR}/output/test_libs" ]; then
    echo "Running test_libs..."
    "${SCRIPT_DIR}/output/test_libs"
    echo "test_libs completed successfully!"
else
    echo "test_libs binary not found"
    exit 1
fi

echo ""
echo "Testing ipdemo..."

# Check if ipdemo exists
if [ -f "${SCRIPT_DIR}/output/ipdemo" ]; then
    echo "Running ipdemo..."
    "${SCRIPT_DIR}/output/ipdemo" || echo "ipdemo test completed!"
else
    echo "ipdemo binary not found - run ./build.sh first"
fi

# Test cprdemo
if [ -f "${SCRIPT_DIR}/output/cprdemo" ]; then
    echo ""
    echo "Testing cprdemo..."
    echo "Running cprdemo..."
    # Run cprdemo and capture both stdout and stderr, ignoring the crash
    "${SCRIPT_DIR}/output/cprdemo" 2>&1 || true
    echo "cprdemo test completed!"
fi

